package com.example.fuzzControll.controller;

import com.alibaba.fastjson.JSON;
import com.example.fuzzControll.exception.ServerException;
import com.example.fuzzControll.pojo.vo.AjaxResult;
import com.example.fuzzControll.service.GetServerMessageService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;

/**
 * kitty服务器信息
 */
@RestController
@RequestMapping("/kittyServer")
@Slf4j
public class KittyServerMessageController {
    @Autowired
    GetServerMessageService getServerMessageService;
    /**
     * 获取服务器stats信息
     */
    @RequestMapping(value = "/stats", method = RequestMethod.GET)
    public AjaxResult getStats( ) {
        try {
            return AjaxResult.success(JSON.parse(getServerMessageService.getStats()));
        } catch (ServerException e) {
            log.error(e.getDefaultMessage());
            return AjaxResult.error("stats信息获取失败！");
        }
    }
    /**
     * 获取服务器templateInfo信息
     */
    @RequestMapping(value = "/templateInfo", method = RequestMethod.GET)
    public AjaxResult getTemplateInfo( ) {
        try {
            return AjaxResult.success(JSON.parse(getServerMessageService.getTemplateInfo()));
        } catch (ServerException e) {
            log.error(e.getDefaultMessage());
            return AjaxResult.error("templateInfo信息获取失败！");
        }
    }
    /**
     * 获取服务器stages信息
     */
    @RequestMapping(value = "/stages", method = RequestMethod.GET)
    public AjaxResult getStages( ) {
        try {
            return AjaxResult.success(JSON.parse(getServerMessageService.getStages()));
        } catch (ServerException e) {
            log.error(e.getDefaultMessage());
            return AjaxResult.error("stages信息获取失败！");
        }
    }
    /**
     * 获取服务器report信息
     */
    @RequestMapping(value = "/report", method = RequestMethod.GET)
    public AjaxResult getReport( ) {
        try {
            return AjaxResult.success(JSON.parse(getServerMessageService.getReport()));
        } catch (ServerException e) {
            log.error(e.getDefaultMessage());
            return AjaxResult.error("report信息获取失败！");
        }
    }
}
