package com.example.fuzzControll.controller.dataController;

import com.example.fuzzControll.pojo.vo.AjaxResult;
import com.example.fuzzControll.pojo.vo.KittyDataParams;
import com.example.fuzzControll.pojo.vo.KittyResult;
import com.example.fuzzControll.service.KittyFuzzPersistenceService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/kittyServer")
@Slf4j
public class KittyDataController {
    @Autowired
    KittyFuzzPersistenceService fuzzPersistenceService;

    /**
     * 查询kitty结果
     */
    @RequestMapping(value = "/KittyResultSelect", method = RequestMethod.GET)
    public AjaxResult KittyResultSelect() {
        List<KittyResult> results;
        try {
            results = fuzzPersistenceService.getKittyResults();
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error();
        }
        return AjaxResult.success(results);
    }

    /**
     * 查询kittyPackage
     */
    @RequestMapping(value = "/kittyPackageFileLoad", method = RequestMethod.POST)
    public AjaxResult kittyPackageFileLoad(@RequestBody KittyDataParams kittyDataParams) {
        try {
            fuzzPersistenceService.loadKittyLogFileInLocal(kittyDataParams);
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error();
        }
        return AjaxResult.success("load success!");
    }
}
