package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.conf.AflnetProperties;
import com.example.fuzzControll.conf.SpringContextUtil;
import com.example.fuzzControll.conf.KittyProperties;
import com.example.fuzzControll.constents.CmdConstent;
import com.example.fuzzControll.exception.AflnetException;
import com.example.fuzzControll.exception.CmdException;
import com.example.fuzzControll.pojo.vo.CmdStartParams;
import com.example.fuzzControll.service.AflnetPersistenceService;
import com.example.fuzzControll.service.TestService;
import com.example.fuzzControll.tools.CmdTools;
import com.example.fuzzControll.tools.GlobalParameters;
import com.example.fuzzControll.tools.TestControlTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.concurrent.CountDownLatch;

@Service("testService")
@Slf4j
public class TestServiceImpl implements TestService {

    CmdTools cmdTools = new CmdTools();
    @Autowired
    AflnetPersistenceService aflnetPersistenceService;

    @Autowired
    AflnetProperties aflnetProperties;

    //todo 不同服务不同端口
    @Override
    public void testStart(CmdStartParams cmdStartParams) throws AflnetException, CmdException {
        TestControlTools.setIsRunning(true);
        String cmd = cmdTools.parse(cmdStartParams);
        Date date = new Date();
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd-hh-mm-ss-");
        String outputFileName = df.format(date)+cmdStartParams.getProtopcol()+"-output";
        String finalCmd = CmdConstent.RUN_AFLNET_BEFORE + outputFileName + CmdConstent.RUN_AFLNET_AFTER + cmd + aflnetProperties.getAflnetPath() + "live555/testProgs/testOnDemandRTSPServer 8554";
        GlobalParameters.aflnetData.put("aflnetName", outputFileName);
        log.info("The cmd is [{}]",finalCmd);
        cmdTools.runProgramCmd(finalCmd, outputFileName + ".zip");

    }


    @Override
    public void testStop() {
        TestControlTools.setIsRunning(false);
        log.info("Aflnet has been stopped ! ");
        try {
            new Thread(new Runnable() {
                @Override
                public void run() {
                    int flag = 0;
                    String fileName = GlobalParameters.aflnetData.get("aflnetName");
                    String fileZipName = fileName + ".zip";
                    cmdTools.runCmd(CmdConstent.RUN_ZIP_FILE + fileZipName + " " + fileName, "zip file in testStart");
                    List<String> files = cmdTools.runCmd(CmdConstent.GET_FILE_NAME + aflnetProperties.getOutputPath(), "getSeedFiles");
                    while (files.contains(fileZipName) && flag == 0) {//当前存在压缩包才存入
                        flag = aflnetPersistenceService.aflnetResultBackup(fileZipName,GlobalParameters.aflnetData.get("missionName"));
                    }
                    /*清除生成的文件*/
                    try {
                        cmdTools.runCmd(CmdConstent.DELETE_FILE+fileName,"delete file");
                        cmdTools.runCmd(CmdConstent.DELETE_FILE+fileZipName,"delete zipFile");
                    } catch (CmdException e) {
                        e.printStackTrace();
                        log.error("file delete failed!");
                    }

                    log.info("kittyLog has been backuped!");
                }
            }).start();
        } catch (Exception e) {
            log.error("AflnetBackup Error!");
            e.printStackTrace();
        }
    }
}
